刷题之旅从数组类型的题目开始。刷题网站为leetcode的中文版:https://leetcode-cn.com/problemset/all/第一道题目是两数之和,对应leetcode的题号为1。

image

题目描述

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那两个整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解题思路

第一次想到的思路是双层循环暴力找出两个条件的值:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] res = new int[2];
for(int i=0;i<nums.length-1;i++){
for(int j=i+1;j<nums.length;j++){
if(nums[i] + nums[j] == target){
res[0] = i;
res[1] = j;
return res;
}
}
}
return res;
}
}

那么如何提到执行效率呢?降低时间复杂度,此时可以接用java中的HashMap数据结构来辅助我们,因为我们知道,这个数据接口可以帮助我们很快地找到对应的元素,那么思路就是:将数据的值作为key,其索引值作为value,那么我们可以根据key来找另一个key,比如我遍历数组到第一个数字2,那么此时map里面存储的是map<2,0>,那么我下次就可以去寻找有没有map<7,x>这样的数据,有的话那就直接返回了,没有则继续去找,直到找不到为止。

提交代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import java.util.Map;
import java.util.HashMap;
class Solution {
public int[] twoSum(int[] nums, int target) {
int[] res = new int[2];
HashMap<Integer,Integer> map = new HashMap<>();
for(int i=0;i<nums.length;i++){
if(map.containsKey(target-nums[i])){
res[0] = i;
res[1] = map.get(target-nums[i]);
return res;
}
//数组值为key,索引为value
map.put(nums[i],i);
}
return res;
}
}